package xugu

// 定义 HANDLE_TYPE 枚举
type HANDLE_TYPE int

const (
	HT_UNKNOW   HANDLE_TYPE = iota // 0 未知
	HT_CONN                        // 1 连接
	HT_PARAMS                      // 2 参数
	HT_ERR                         // 错误
	HT_RS                          // 结果
	HT_LOB                         // 大对象
	HT_SMART_RS                    // 智能结果集
)
const (
	XG_OK = iota
)

const (
	XG_ERROR        = -1
	XG_NET_ERROR    = -4
	XG_INVALID_ARG  = -3
	XG_SOCKET_ERROR = -8
	XG_LOGIN_ERROR  = -9
)

const (
	ERROR_BUFF_SIZE        uint = 1024
	PREPARE_NAME_BUFF_SIZE uint = 128
	CURSOR_NAME_BUFF_SIZE  uint = 128
	ROWID_BUFF_SIZE        uint = 256
	COLUMN_NAME_BUFF_SIZE  uint = 256

	FIELD_BUFF_SIZE uint = 4096
	LOB_BUFF_SIZE   uint = 8
	RET_NO_DATA     int  = 100

	// SQL_UNKNOWN   int = 0
	// SQL_SELECT    int = 4
	// SQL_CREATE    int = 5
	// SQL_PROCEDURE int = 10

	SQL_PARAM_INPUT       int = 1
	SQL_PARAM_OUTPUT      int = 2
	SQL_PARAM_INPUTOUTPUT int = 3
	SQL_PARAM_RETURNVALUE int = 6

	SQL_XG_C_CHAR int = 2
	SQL_XG_C_CLOB int = 41
	SQL_XG_C_BLOB int = 42
	SQL_XG_C_NULL int = -11

	BIND_PARAM_BY_NAME int = 2
	BIND_PARAM_BY_POS  int = 1
)

// SQL类型常量
const (
	SQL_UNKNOWN = iota
	SQL_SELECT
	SQL_INSERT
	SQL_UPDATE
	SQL_DELETE
	SQL_CREATE
	SQL_ALTER
	SQL_PROCEDURE
	SQL_OTHER
)

const (
	TYPE_EMPTY        = 0
	TYPE_NULL         = 1
	TYPE_BOOL         = 2
	TYPE_I1           = 3
	TYPE_I2           = 4
	TYPE_I4           = 5
	TYPE_I8           = 6
	TYPE_NUM          = 7
	TYPE_R4           = 8
	TYPE_R8           = 9
	TYPE_DATE         = 10
	TYPE_TIME         = 11
	TYPE_TIME_TZ      = 12
	TYPE_DATETIME     = 13
	TYPE_DATETIME_TZ  = 14
	TYPE_INTERVAL_Y   = 15
	TYPE_INTERVAL_Y2M = 16
	TYPE_INTERVAL_M   = 17
	TYPE_INTERVAL_D   = 18
	TYPE_INTERVAL_D2H = 19
	TYPE_INTERVAL_H   = 20
	TYPE_INTERVAL_D2M = 21
	TYPE_INTERVAL_H2M = 22
	TYPE_INTERVAL_MI  = 23
	TYPE_INTERVAL_D2S = 24
	TYPE_INTERVAL_H2S = 25
	TYPE_INTERVAL_M2S = 26
	TYPE_INTERVAL_S   = 27
	TYPE_ROWVER       = 28
	TYPE_GUID         = 29
	TYPE_CHAR         = 30
	TYPE_NCHAR        = 31
	TYPE_CLOB         = 32
	TYPE_BINARY       = 33
	TYPE_BLOB         = 34
	TYPE_GEOM         = 35
	TYPE_POINT        = 36
	TYPE_BOX          = 37
	TYPE_POLYLINE     = 38
	TYPE_POLYGON      = 39
	TYPE_BLOB_I       = 40
	TYPE_BLOB_S       = 41
	TYPE_BLOB_M       = 42
	TYPE_BLOB_OM      = 43
	TYPE_STREAM       = 44
	TYPE_ROWID        = 45
	TYPE_SIBLING      = 46
	TYPE_MAX_SYS      = 47
	TYPE_BLADE_BEGIN  = 101
	TYPE_BLADE_END    = 1000
	TYPE_OBJECT       = 1001
	TYPE_REFROW       = 1002
	TYPE_RECORD       = 1003
	TYPE_VARRAY       = 1004
	TYPE_TABLE        = 1005
	TYPE_ITABLE       = 1006
	TYPE_CURSOR       = 1007
	TYPE_REFCUR       = 1008
	TYPE_ROWTYPE      = 1009
	TYPE_COLTYPE      = 1010
	TYPE_CUR_REC      = 1011
	TYPE_PARAM        = 1012
)

const (
	XG_C_NULL                   = 0
	XG_C_BOOL                   = 1
	XG_C_CHAR                   = 2
	XG_C_TINYINT                = 3
	XG_C_SHORT                  = 4
	XG_C_INTEGER                = 5
	XG_C_BIGINT                 = 6
	XG_C_FLOAT                  = 7
	XG_C_DOUBLE                 = 8
	XG_C_NUMERIC                = 9
	XG_C_DATE                   = 10
	XG_C_TIME                   = 11
	XG_C_TIME_TZ                = 12
	XG_C_DATETIME               = 13
	XG_C_DATETIME_TZ            = 14
	XG_C_BINARY                 = 15
	XG_C_INTERVAL               = 21
	XG_C_INTERVAL_YEAR_TO_MONTH = 28
	XG_C_INTERVAL_DAY_TO_SECOND = 31
	XG_C_CLOB                   = 41
	XG_C_BLOB                   = 42
)

const XG_C_NCHAR = 162 /* only for c# wchar use */
const XG_C_CHARN1 = 163
const DATETIME_ASLONG = 123

const XG_PARAM_NAME_ERR = -53
const XG_BIND_PARAM_ERROR = -59
